'We use one function (to shorten this main part heh)
DECLARE FUNCTION Rep$ (I!, S$)

'There is one string array that holds all the tiles in the board.
DIM Tiles$(1500)

'Personally I prefer lowercase command lines. :)
cmdline$ = LCASE$(COMMAND$)

'Introduce the user to this tool.
CLS
BLOAD "INTRO.SCR"
I$ = INPUT$(1)

'Clear the screen, show a .BSV file list, and input for the file name.
CLS
FILES "*.BSV"
LINE INPUT "Enter file name:", A$

'Make it lowercase (useless), and remove the extension, if any.
A$ = LCASE$(A$)
IF INSTR(A$, ".") THEN A$ = LEFT$(A$, INSTR(A$, ".") - 1)

'Load the file to the screen.
'  ***FIXME: the program will crash here if the file does not exist.
'            Needs an ON ERROR routine.
BLOAD A$ + ".bsv"

'Read the characters directly off the screen and translate them to actual
'  ZZT board objects.
DEF SEG = &HB800
FOR Y = 0 TO 24
    FOR X = 0 TO 59
        Offset = (X + Y * 80) * 2
        CurTile = CurTile + 1
        G = PEEK(Offset)
        L$ = CHR$(0)
        SELECT CASE G
            CASE 2
                PX = X
                PY = Y
                L$ = CHR$(4)
            CASE &H20
                L$ = CHR$(0)
                I = PEEK(Offset + 1)
                IF I > 15 THEN L$ = "Text"
            CASE &H84
                L$ = CHR$(5)
            CASE &H9D
                L$ = CHR$(6)
            CASE &H4
                L$ = CHR$(7)
            CASE &HC
                L$ = CHR$(8)
            CASE &HA
                L$ = CHR$(9)
            CASE &HE8
                'Support for scrolls not implemented yet.
                'L$ = CHR$(&HA)
            CASE &HF0
                'Support for passages not implemented yet.
                'L$ = CHR$(&HB)
            CASE &HFA
                'Support for duplicators not implemented yet.
                'L$ = CHR$(&HC)
            CASE &HB
                L$ = CHR$(&HD)
            CASE &H7F
                L$ = CHR$(&HE)
            'Conveyors n stars n stuff not implemented yet...
            'F=star,10=Clockwise,11=Counterclockwise
            CASE &HF8
                'Support for bullets not implemented yet.
                'L$ = CHR$(&H12)
            CASE &HB0
                I = PEEK(Offset + 1)
                L$ = CHR$(&H13)               'make it water
                IF I = 32 THEN L$ = CHR$(&H14)  'make it forest if it's green
                'Invisible is &H1C
            CASE &HDB
                L$ = CHR$(&H15)'very very solid...
            CASE &HB2
                L$ = CHR$(&H16)'normal...
                'or fake, which is &H1B
            CASE &HB1
                L$ = CHR$(&H17)
            CASE &HFE
                L$ = CHR$(&H18)
            CASE &H12
                L$ = CHR$(&H19)
            CASE &H1D
                L$ = CHR$(&H1A)
            '1D Blink Wall, 1E Transporter, 1F Line
            CASE &H2A
                'Ricochet
                '  Character conflicts with slime. The player will most
                '  likely get the slime color from STK kits or whatever.
                '  This astreik is being a bullet bouncer!
                L$ = CHR$(&H20)
            CASE &HCD
                L$ = CHR$(&H21)
            CASE &H99
                'Support for bears not implemented yet...
                'L$ = CHR$(&H22)
            CASE &H5
                'Support for Ruffians not implemented yet...
                'L$ = CHR$(&H23)
            CASE &H1
                'Support for objects not implemented yet...
                'L$ = CHR$(&H24)
            'CASE &H2A
                'Support for slime not implemented yet...
                'L$ = CHR$(&H25)
            'CASE &H5E
                'Support for sharks not implemented yet...
                'L$ = CHR$(&H26)
            '27 Spinning Gun, 28 Pusher
            CASE &HEA
                'Support for Lions not implemented yet...
                'L$ = CHR$(&H29)
            CASE &HE3
                'Support for Tigers not implemented yet...
                'L$ = CHR$(&H2A)
            CASE &HBA
                L$ = CHR$(&H2B)
            CASE &HE9
                'Support for Centipede Heads not implemented yet...
                'L$ = CHR$(&H2C)
            'CASE &H4F
                'Support for Centipede Segments not implemented yet...
                'L$ = CHR$(&H2D)
            CASE ELSE
                'Special keyword, alerts the program to make a text entry.
                L$ = "Text"
            END SELECT
        H$ = L$ + CHR$(PEEK(Offset + 1))
       
        'If the special keyword was used, then act accordingly...
        IF L$ = "Text" THEN
                I = PEEK(Offset + 1)
                I = FIX(I / 16)
                IF I = 0 THEN I = 7
                I = I + &H2E
                H$ = CHR$(I) + CHR$(PEEK(Offset))
            END IF

        'DEBUG: If the length of H$ somehow did NOT end up being two, crash
        '  the program. If there's a resume it will force the length to be 2.
        IF LEN(H$) <> 2 THEN
                ERROR 255
                H$ = LEFT$(H$ + CHR$(0) + CHR$(0), 2)
            END IF
 
        'Record the tile. :)
        Tiles$(CurTile) = H$
    NEXT X
NEXT Y

'Force a player at PX,PY - the purpose of this is in case there is a bug, the
'  player will be "forced" at a location where the first object on the board
'  will say he is. If you wanna be creative go ahead and make this a ruffian
'  or something, you just won't be able to exit the game if you do hehehe ;)
Tiles$(PX + PY * 60 + 1) = CHR$(4) + CHR$(31)

'Make the run-length encoding...
FOR X = 1 TO 1500
    'Take the tile and record it to a string for easier reference.
    J$ = Tiles$(X)

    'All conditions of terminating a run-length. If none are met, then
    '  increment the "number" of tiles that match the previous one instead
    '  of recording a new set of tiles.
    IF J$ <> OldJ$ OR Num = 255 OR INSTR(cmdline$, "-nocompress") THEN
            IF Num THEN
                    Set$ = Set$ + CHR$(Num) + OldJ$
                END IF
            Num = 1
        ELSE
            Num = Num + 1
        END IF

    'This helps the engine figure out when to terminate the run-length, and
    '  it also records THIS character rather than the new one.
    OldJ$ = J$
NEXT X

'if any remaining... (and there should be!)
IF Num THEN
        Set$ = Set$ + CHR$(Num) + OldJ$
    END IF

'OK. We're done with the biggest part of the board, the terrain. Now for the
'info and player...

'255 shots per board, and lots of padding, then make ONE object.
Info$ = CHR$(255) + STRING$(7, 0) + STRING$(58, 0)
Info$ = Info$ + STRING$(2, 0) + STRING$(18, 0)
Info$ = Info$ + MKI$(1)

'This is the player object. Where the last 0x02 character was placed will
'be its location.
Player$ = CHR$(PX + 1) + CHR$(PY + 1) + STRING$(4, 0) + MKI$(1)
Player$ = Player$ + STRING$(9, 0) + STRING$(8, 0) + STRING$(8, 0)

'For some odd reason, ZZT crashes without this, so this will be here.
Player$ = Player$ + Rep$(11, CHR$(0) + CHR$(111) + CHR$(1)) + CHR$(0)

'Clear out a gray space on the screen to input the title
LOCATE 2, 1
COLOR 0, 7
FOR X = 80 TO 239
    POKE X * 2, 32
    POKE X * 2 + 1, 112
NEXT X

'Prompt the user to enter the title of the board.
PRINT "Enter a name for this board (max 33 chars):"
LINE INPUT BoardName$

'Parse the board's name. First, chop off all characters after #33.
BoardName$ = LEFT$(BoardName$, 33)

'Take its new length, record it,
'  then pad the rest of the 33 characters if needed.
BoardName$ = CHR$(LEN(BoardName$)) + LEFT$(BoardName$ + STRING$(33, 0), 33)

'Header is the board name and another 17 padding characters.
Header$ = BoardName$ + STRING$(17, 0)

'Take the total size of ALL this information.
Size$ = MKI$(LEN(Header$) + LEN(Set$) + LEN(Info$) + LEN(Player$))

'Output all 5 strings sequentially without causing a string overflow.
OPEN "O", #1, A$ + ".brd"
PRINT #1, Size$;
PRINT #1, Header$;
PRINT #1, Set$;
PRINT #1, Info$;
PRINT #1, Player$;
CLOSE #1

'Clear the screen and that's it! :) That wasn't too hard, was it?
COLOR 7, 0
CLS

FUNCTION Rep$ (I, S$)
    FOR K = 1 TO I
        T$ = T$ + S$
    NEXT K
    Rep$ = T$
END FUNCTION

